﻿:Namespace Census
    WINDOWS←#.Util.InitCauseway ⎕THIS

    ∇ LX;sp;log
      Update ¯1    ⍝ only if necessary
      sp←Plot(log←0)
      #.Util.View sp
      :If WINDOWS
          sp.SaveImage'Census.png'System.Drawing.Imaging.ImageFormat.Png 256
      :EndIf
      sp.SaveSvg'Census.svg'Causeway.SvgMode.FixedAspect
      ⎕←'Files saved to "',(,⎕SE.UCMD']cd'),'"'
    ∇

    ∇ Update n;mat
      :If (0=⎕NC'CENSUS')∨(n≥0)
          mat←ReadCensus
          :If n>0 ⋄ mat←mat[n?⊃⍴mat;] ⋄ :EndIf   ⍝ take n random samples
          MakeCensus mat
      :EndIf
    ∇


    ∇ mat←ReadCensus;tie;txt;nl
     
      tie←'census-income.data'⎕NTIE 0
      txt←'UTF-8'⎕UCS ⎕NREAD tie 83(⎕NSIZE tie)0
      ⎕NUNTIE tie
     
      nl←⎕UCS 10 ⋄ txt←¯1↓1↓¨(nl=txt)⊂txt←nl,txt  ⍝ cut at new line (first entry doesn't have it - last line is empty)
      txt←{2↓¨(','=x)⊂x←', ',⍵}¨txt       ⍝ cut deeper at ', ' (first entry doesn't have it)
      mat←↑txt                          ⍝ matrix[entry;attributes]
     
       ⍝ attributes :
       ⍝  1 - age: continuous.
       ⍝  2 - class of worker: Not in universe, Federal government, Local government, Never worked, Private, Self-employed-incorporated, Self-employed-not incorporated, State government, Without pay.
       ⍝  3 - detailed industry recode: 0, 40, 44, 2, 43, 47, 48, 1, 11, 19, 24, 25, 32, 33, 34, 35, 36, 37, 38, 39, 4, 42, 45, 5, 15, 16, 22, 29, 31, 50, 14, 17, 18, 28, 3, 30, 41, 46, 51, 12, 13, 21, 23, 26, 6, 7, 9, 49, 27, 8, 10, 20.
       ⍝  4 - detailed occupation recode: 0, 12, 31, 44, 19, 32, 10, 23, 26, 28, 29, 42, 40, 34, 14, 36, 38, 2, 20, 25, 37, 41, 27, 24, 30, 43, 33, 16, 45, 17, 35, 22, 18, 39, 3, 15, 13, 46, 8, 21, 9, 4, 6, 5, 1, 11, 7.
       ⍝  5 - education: Children, 7th and 8th grade, 9th grade, 10th grade, High school graduate, 11th grade, 12th grade no diploma, 5th or 6th grade, Less than 1st grade, Bachelors degree(BA AB BS), 1st 2nd 3rd or 4th grade, Some college but no degree, Masters degree(MA MS MEng MEd MSW MBA), Associates degree-occup /vocational, Associates degree-academic program, Doctorate degree(PhD EdD), Prof school degree (MD DDS DVM LLB JD).
       ⍝  6 - wage per hour: continuous.
       ⍝  7 - enroll in edu inst last wk: Not in universe, High school, College or university.
       ⍝  8 - marital stat: Never married, Married-civilian spouse present, Married-spouse absent, Separated, Divorced, Widowed, Married-A F spouse present.
       ⍝  9 - major industry code: Not in universe or children, Entertainment, Social services, Agriculture, Education, Public administration, Manufacturing-durable goods, Manufacturing-nondurable goods, Wholesale trade, Retail trade, Finance insurance and real estate, Private household services, Business and repair services, Personal services except private HH, Construction, Medical except hospital, Other professional services, Transportation, Utilities and sanitary services, Mining, Communications, Hospital services, Forestry and fisheries, Armed Forces.
       ⍝ 10 - major occupation code: Not in universe, Professional specialty, Other service, Farming forestry and fishing, Sales, Adm support including clerical, Protective services, Handlers equip cleaners etc , Precision production craft & repair, Technicians and related support, Machine operators assmblrs & inspctrs, Transportation and material moving, Executive admin and managerial, Private household services, Armed Forces.
       ⍝ 11 - race: White, Black, Other, Amer Indian Aleut or Eskimo, Asian or Pacific Islander.
       ⍝ 12 - hispanic origin: Mexican (Mexicano), Mexican-American, Puerto Rican, Central or South American, All other, Other Spanish, Chicano, Cuban, Do not know, NA.
       ⍝ 13 - sex: Female, Male.
       ⍝ 14 - member of a labor union: Not in universe, No, Yes.
       ⍝ 15 - reason for unemployment: Not in universe, Re-entrant, Job loser - on layoff, New entrant, Job leaver, Other job loser.
       ⍝ 16 - full or part time employment stat: Children or Armed Forces, Full-time schedules, Unemployed part- time, Not in labor force, Unemployed full-time, PT for non-econ reasons usually FT, PT for econ reasons usually PT, PT for econ reasons usually FT.
       ⍝ 17 - capital gains: continuous.
       ⍝ 18 - capital losses: continuous.
       ⍝ 19 - dividends from stocks: continuous.
       ⍝ 20 - tax filer stat: Nonfiler, Joint one under 65 & one 65+, Joint both under 65, Single, Head of household, Joint both 65+.
       ⍝ 21 - region of previous residence: Not in universe, South, Northeast, West, Midwest, Abroad.
       ⍝ 22 - state of previous residence: Not in universe, Utah, Michigan, North Carolina, North Dakota, Virginia, Vermont, Wyoming, West Virginia, Pennsylvania, Abroad, Oregon, California, Iowa, Florida, Arkansas, Texas, South Carolina, Arizona, Indiana, Tennessee, Maine, Alaska, Ohio, Montana, Nebraska, Mississippi, District of Columbia, Minnesota, Illinois, Kentucky, Delaware, Colorado, Maryland, Wisconsin, New Hampshire, Nevada, New York, Georgia, Oklahoma, New Mexico, South Dakota, Missouri, Kansas, Connecticut, Louisiana, Alabama, Massachusetts, Idaho, New Jersey.
       ⍝ 23 - detailed household and family stat: Child <18 never marr not in subfamily, Other Rel <18 never marr child of subfamily RP, Other Rel <18 never marr not in subfamily, Grandchild <18 never marr child of subfamily RP, Grandchild <18 never marr not in subfamily, Secondary individual, In group quarters, Child under 18 of RP of unrel subfamily, RP of unrelated subfamily, Spouse of householder, Householder, Other Rel <18 never married RP of subfamily, Grandchild <18 never marr RP of subfamily, Child <18 never marr RP of subfamily, Child <18 ever marr not in subfamily, Other Rel <18 ever marr RP of subfamily, Child <18 ever marr RP of subfamily, Nonfamily householder, Child <18 spouse of subfamily RP, Other Rel <18 spouse of subfamily RP, Other Rel <18 ever marr not in subfamily, Grandchild <18 ever marr not in subfamily, Child 18+ never marr Not in a subfamily, Grandchild 18+ never marr not in subfamily, Child 18+ ever marr RP of subfamily, Other Rel 18+ never marr not in subfamily, Child 18+ never marr RP of subfamily, Other Rel 18+ ever marr RP of subfamily, Other Rel 18+ never marr RP of subfamily, Other Rel 18+ spouse of subfamily RP, Other Rel 18+ ever marr not in subfamily, Child 18+ ever marr Not in a subfamily, Grandchild 18+ ever marr not in subfamily, Child 18+ spouse of subfamily RP, Spouse of RP of unrelated subfamily, Grandchild 18+ ever marr RP of subfamily, Grandchild 18+ never marr RP of subfamily, Grandchild 18+ spouse of subfamily RP.
       ⍝ 24 - detailed household summary in household: Child under 18 never married, Other relative of householder, Nonrelative of householder, Spouse of householder, Householder, Child under 18 ever married, Group Quarters- Secondary individual, Child 18 or older.
       ⍝ 25 - instance weight: continuous.
       ⍝ 26 - migration code-change in msa: Not in universe, Nonmover, MSA to MSA, NonMSA to nonMSA, MSA to nonMSA, NonMSA to MSA, Abroad to MSA, Not identifiable, Abroad to nonMSA.
       ⍝ 27 - migration code-change in reg: Not in universe, Nonmover, Same county, Different county same state, Different state same division, Abroad, Different region, Different division same region.
       ⍝ 28 - migration code-move within reg: Not in universe, Nonmover, Same county, Different county same state, Different state in West, Abroad, Different state in Midwest, Different state in South, Different state in Northeast.
       ⍝ 29 - live in this house 1 year ago: Not in universe under 1 year old, Yes, No.
       ⍝ 30 - migration prev res in sunbelt: Not in universe, Yes, No.
       ⍝ 31 - num persons worked for employer: continuous.
       ⍝ 32 - family members under 18: Both parents present, Neither parent present, Mother only present, Father only present, Not in universe.
       ⍝ 33 - country of birth father: Mexico, United-States, Puerto-Rico, Dominican-Republic, Jamaica, Cuba, Portugal, Nicaragua, Peru, Ecuador, Guatemala, Philippines, Canada, Columbia, El-Salvador, Japan, England, Trinadad&Tobago, Honduras, Germany, Taiwan, Outlying-U S (Guam USVI etc), India, Vietnam, China, Hong Kong, Cambodia, France, Laos, Haiti, South Korea, Iran, Greece, Italy, Poland, Thailand, Yugoslavia, Holand-Netherlands, Ireland, Scotland, Hungary, Panama.
       ⍝ 34 - country of birth mother: India, Mexico, United-States, Puerto-Rico, Dominican-Republic, England, Honduras, Peru, Guatemala, Columbia, El-Salvador, Philippines, France, Ecuador, Nicaragua, Cuba, Outlying-U S (Guam USVI etc), Jamaica, South Korea, China, Germany, Yugoslavia, Canada, Vietnam, Japan, Cambodia, Ireland, Laos, Haiti, Portugal, Taiwan, Holand-Netherlands, Greece, Italy, Poland, Thailand, Trinadad&Tobago, Hungary, Panama, Hong Kong, Scotland, Iran.
       ⍝ 35 - country of birth self: United-States, Mexico, Puerto-Rico, Peru, Canada, South Korea, India, Japan, Haiti, El-Salvador, Dominican-Republic, Portugal, Columbia, England, Thailand, Cuba, Laos, Panama, China, Germany, Vietnam, Italy, Honduras, Outlying-U S (Guam USVI etc), Hungary, Philippines, Poland, Ecuador, Iran, Guatemala, Holand-Netherlands, Taiwan, Nicaragua, France, Jamaica, Scotland, Yugoslavia, Hong Kong, Trinadad&Tobago, Greece, Cambodia, Ireland.
       ⍝ 36 - citizenship: Native- Born in the United States, Foreign born- Not a citizen of U S , Native- Born in Puerto Rico or U S Outlying, Native- Born abroad of American Parent(s), Foreign born- U S citizen by naturalization.
       ⍝ 38 - fill inc questionnaire for veteran's admin: Not in universe, Yes, No.
       ⍝ 39 - own business or self employed: 0, 2, 1.
       ⍝ 40 - weeks worked in year: continuous.
       ⍝ 41 - year: 94, 95.
       ⍝ 42 - ??? unknown
       ⍝ ?? - veterans benefits: 0, 2, 1.
    ∇

    ∇ MakeCensus mat;n;size;IgnoreEmpty;Replace;LogScale;NumConv;GAINS;LOSSES;DIVIDENDS
      IgnoreEmpty←{(0<⊃∘⍴¨⍵)/⍵}
      Replace←{x←⍺ ⋄ (fm to)←↓⍉↑,⍵ ⋄ mask←(⍴fm)≥i←fm⍳x ⋄ (mask/x)←to[mask/i] ⋄ x}
      LogScale←{mask←0≠x←|⍵ ⋄ (mask/x)←10⍟(mask/x) ⋄ x}
      NumConv←{
          (ok num)←⎕VFI ⍵
          ok≢,1:('Cannot convert : ',⍵)⎕SIGNAL 11
          ⊃num}¨
     
       ⍝ attributes :
      AGE←NumConv mat[;1]        ⍝  1 - age: continuous.
      CLASS←mat[;2]              ⍝  2 - class of worker: Not in universe, Federal government, Local government, Never worked, Private, Self-employed-incorporated, Self-employed-not incorporated, State government, Without pay.
      EDUCATION←mat[;5]          ⍝  5 - education: Children, 7th and 8th grade, 9th grade, 10th grade, High school graduate, 11th grade, 12th grade no diploma, 5th or 6th grade, Less than 1st grade, Bachelors degree(BA AB BS), 1st 2nd 3rd or 4th grade, Some college but no degree, Masters degree(MA MS MEng MEd MSW MBA), Associates degree-occup /vocational, Associates degree-academic program, Doctorate degree(PhD EdD), Prof school degree (MD DDS DVM LLB JD).
      EDUCATION←EDUCATION Replace('7th and 8th grade' '7th-8th')('9th grade' '9th')('10th grade' '10th')('High school graduate' 'High school')('11th grade' '11th')('12th grade no diploma' '12th')('5th or 6th grade' '5th-6th')('Less than 1st grade' '1st')('Bachelors degree(BA AB BS)' 'Bachelor')('1st 2nd 3rd or 4th grade' '4th')('Some college but no degree' 'College')('Masters degree(MA MS MEng MEd MSW MBA)' 'Masters')('Associates degree-occup /vocational' 'Vocational')('Associates degree-academic program' 'Academic')('Doctorate degree(PhD EdD)' 'Doctorate')('Prof school degree (MD DDS DVM LLB JD)' 'Prof school')
      WAGES←NumConv mat[;6]       ⍝  6 - wage per hour: continuous.
      MARITAL←mat[;8]            ⍝  8 - marital stat: Never married, Married-civilian spouse present, Married-spouse absent, Separated, Divorced, Widowed, Married-A F spouse present.
      INDUSTRY←mat[;9]           ⍝  9 - major industry code: Not in universe or children, Entertainment, Social services, Agriculture, Education, Public administration, Manufacturing-durable goods, Manufacturing-nondurable goods, Wholesale trade, Retail trade, Finance insurance and real estate, Private household services, Business and repair services, Personal services except private HH, Construction, Medical except hospital, Other professional services, Transportation, Utilities and sanitary services, Mining, Communications, Hospital services, Forestry and fisheries, Armed Forces.
      OCCUPATION←mat[;10]        ⍝ 10 - major occupation code: Not in universe, Professional specialty, Other service, Farming forestry and fishing, Sales, Adm support including clerical, Protective services, Handlers equip cleaners etc , Precision production craft & repair, Technicians and related support, Machine operators assmblrs & inspctrs, Transportation and material moving, Executive admin and managerial, Private household services, Armed Forces.
      RACE←mat[;11]              ⍝ 11 - race: White, Black, Other, Amer Indian Aleut or Eskimo, Asian or Pacific Islander.
      RACE←RACE Replace('Asian or Pacific Islander' 'Asian')('Amer Indian Aleut or Eskimo' 'Native')
      SEX←mat[;13]               ⍝ 13 - sex: Female, Male.
      GAINS←NumConv mat[;17]     ⍝ 17 - capital gains: continuous.
      LOSSES←NumConv mat[;18]    ⍝ 18 - capital losses: continuous.
      DIVIDENDS←NumConv mat[;19] ⍝ 19 - dividends from stocks: continuous.
      CAPITAL←GAINS+DIVIDENDS-LOSSES ⍝ revenue from capital
      EMPLOYERS←NumConv mat[;31] ⍝ 31 - num persons worked for employer: continuous.
      WEEKS←NumConv mat[;40]     ⍝ 40 - weeks worked in year: continuous.
      CENSUS←1  ⍝ flag initialisation
    ∇







    ∇ sp←Plot log
      sp←⎕NEW Causeway.SharpPlot
      sp.Heading←'1995 US income census'
      sp.DrawFrame
     
      sp.NewFrame 0 300 432 300
      sp.SetTrellis 2 2
     
      sp.XAxisStyle←Causeway.XAxisStyles.(AngledLabels)
      sp.YAxisStyle←+/1 1 log/Causeway.YAxisStyles.(GridLines AtEndCaption LogScale)
      sp.BoxPlotStyle←Causeway.BoxPlotStyles.(CroppedAxes+DecileWhiskers)
      sp.FillStyles←Causeway.FillStyle.Saturate80
      sp.SetColors⊂System.Drawing.Color.(Maroon Navy)
     
      :If 1
          sp.YCaption←'Wages',log/' (log)' ⋄ sp.MissingValue←0
          sp.NewCell ⋄ sp.XCaption←'Race' ⋄ sp.DrawBoxPlot WAGES RACE SEX
          sp.NewCell ⋄ sp.XCaption←'Education' ⋄ sp.DrawBoxPlot WAGES EDUCATION SEX
     
          sp.YCaption←'Capital revenue',log/' (log)' ⋄ sp.MissingValue←0
          sp.NewCell ⋄ sp.XCaption←'Race' ⋄ sp.DrawBoxPlot CAPITAL RACE SEX
          sp.NewCell ⋄ sp.XCaption←'Education' ⋄ sp.DrawBoxPlot CAPITAL EDUCATION SEX
      :EndIf
    ∇


:EndNamespace