﻿:Namespace SA2Service
   
    Debug←1                                   
    ServiceName←'SA2Service'
    WSID←'c:\users\mkrom\dyalog17\sa2\SA2Service.dws'
    runtime←1 
    maxws←'100M'       
    PARAMS←'' ⍝ Any other command line params
    RIDE_INIT←''

    ∇ r←Start site;tgt;svc;Root
  ⍝ This is the program used to initialize a Windows Service
  ⍝ It can be run in development mode or runtime mode
     
      :If Debug∧' '∧.=2 ⎕NQ'.' 'GetEnvironment' 'RIDE_INIT'
          {}3502⌶⍬ ⍝ Enable RIDE debugging 
      :Else
          ⍝ /// Insert error trapping / logging here
      :EndIf
     
      ServiceName←2 ⎕NQ'.' 'GetEnvironment' 'APL_ServiceRun' ⍝ Running as a service
      AsAService←0≠≢ServiceName
      WindowsServiceConstants
     
      :If AsAService
          ⎕←'Running as a Windows Service "',ServiceName,'"'
          '.'⎕WS'Event' 'ServiceNotification' 'WindowsServiceHandler'
          30 SetServiceStatus SERVICE_START_PENDING
      :EndIf
          
      ⍝ ... application initialisation goes here ..     
      SetServiceStatus SERVICE_RUNNING
     
      :If (⎕TID=0)∧'Dev'≢3↑4⊃'.'⎕WG'APLVersion'     ⍝ If this is a runtime and we are in thread 0
          :If AsAService                            ⍝ Either
              ⎕DQ'.' ⍝ Receive Windows Service Control Manager events - see WindowsServiceHandler
          :Else                                     ⍝ Or
              :While 1≠⍴⎕TNUMS ⋄ ⎕DL 5 ⋄ :EndWhile  ⍝ Hang about while anything else is going on
          :EndIf
      :EndIf
    ∇

    ∇Stop
    ⍝ // whatever the application needs to do on shutdown
    ∇

    ∇ {waithint}SetServiceStatus curstate;state
      :If AsAService
          state←7↑16 curstate 1
          ⍝ [1] serviceType      = SERVICE_WIN32_OWN_PROCESS
          ⍝ [2] currentState     = wha'evva
          ⍝ [3] controlsAccepted = SERVICE_ACCEPT_STOP
          :If 2=⎕NC'waithint' ⋄ state[7]←waithint×1000 ⋄ :EndIf ⍝ How long will this take?
     
          {}2 ⎕NQ'.' 'SetServiceState'state
      :EndIf
    ∇

    ∇ r←WindowsServiceHandler(obj event action state)
      ⎕←event action state
      r←0
     
      :Select ServiceControl←action
      :CaseList SERVICE_CONTROL_STOP SERVICE_CONTROL_SHUTDOWN
          30 SetServiceStatus SERVICE_STOP_PENDING ⍝ Say it might take 30 secs
          ⎕←'Stopping'
          
          Stop ⍝ /// application shutdown code goes here ///

          :While 1≠⍴⎕TNUMS ⋄ ⎕←'.' ⋄ ⎕DL 1 ⋄ :EndWhile
          SetServiceStatus SERVICE_STOPPED
          ⎕OFF
     
      :Else
          ⎕←'Unable to handle'event action state
      :EndSelect
    ∇
    
    ∇ r←ServiceInstall;ws;proc;z;session
    ⍝ Install DFS as a Windows Service
     
      ws←'"',WSID,'"' ⍝ /// customise this
     
      ⎕←'Current service configuation settings are:' ⋄ ⎕←''
      ⎕←'name' 'maxws' 'ride_init' 'params' 'runtime',⍪ServiceName maxws ride_init params runtime ⋄ ⎕←''
      :If runtime≡0
          ⎕←'*** WARNING: runtime is set to 0, this may prevent successful start of services due to GDI resource limitations ***'
      :EndIf
      ⎕←'Edit the <startedtask> section of config.xml to make changes.'
      ⎕←''
     
      :If Confirm'Install Windows Service "',ServiceName,'"? '
     
          ride_init←RIDE_INIT ⋄ ((ride_init='*')/ride_init)←'0' ⍝ Fill in wild cards
          params←'APL_ServiceInstall="',ServiceName,'" '
          params,←' MAXWS=',maxws,{0=⍴⍵:'' ⋄ ' RIDE_INIT="',⍵,'"'}ride_init
          params,←' ',PARAMS
     
          proc←⎕NEW ##.APLProcess(ws params runtime)
      :EndIf
    ∇

    ∇ ServiceUninstall name;ws;params;proc;runtime
    ⍝ Uninstall Windows Service
     
      :If name≡'' ⋄ name←ServiceName ⋄ :EndIf
     
      :If name≢ServiceName
          ⎕←'NB. Current configuration uses name "',ServiceName,'"!'
      :EndIf
     
      :If Confirm'Uninstall Windows Service "',name,'"? '
          runtime←0
          ws←'"',WSID,'"'
          params←'APL_ServiceUninstall="',name,'"'
          proc←⎕NEW ##.APLProcess(ws params runtime)
      :EndIf
    ∇

    ∇ WindowsServiceConstants
 ⍝ Service states are as follows:
      SERVICE_STOPPED←1
      SERVICE_START_PENDING←2
      SERVICE_STOP_PENDING←3
      SERVICE_RUNNING←4
      SERVICE_CONTINUE_PENDING←5
      SERVICE_PAUSE_PENDING←6
      SERVICE_PAUSED←7
     
 ⍝ Service Control Codes (actions) are as follows:
      SERVICE_CONTROL_STOP←1
      SERVICE_CONTROL_PAUSE←2
      SERVICE_CONTROL_CONTINUE←3
      SERVICE_CONTROL_INTERROGATE←4
      SERVICE_CONTROL_SHUTDOWN←5
      SERVICE_CONTROL_PARAMCHANGE←6
      SERVICE_CONTROL_NETBINDADD←7
      SERVICE_CONTROL_NETBINDREMOVE←8
      SERVICE_CONTROL_NETBINDENABLE←9
      SERVICE_CONTROL_NETBINDDISABLE←10
      SERVICE_CONTROL_DEVICEEVENT←11
      SERVICE_CONTROL_HARDWAREPROFILECHANGE←12
      SERVICE_CONTROL_POWEREVENT←13
      SERVICE_CONTROL_SESSIONCHANGE←14
      SERVICE_CONTROL_PRESHUTDOWN←15
    ∇

:EndNamespace
