﻿:Namespace Util
    ⍝ To use this namespace, do :
    ⍝ WINDOWS←#.Util.InitCauseway ⎕THIS

    WINDOWS←1  ⍝ set to zero if non-windows platform
    LOCAL←1    ⍝ set to zero to use sharpplot from $DYALOG directory, rather than from local directory

    ∇ windows←InitCauseway ns;path
      windows←WINDOWS
      :If 0=ns.⎕NC'Causeway'
          :If WINDOWS ⍝ use the .Net version
              path←LOCAL/'.\'
              ns.⎕USING←',system.dll' ',system.drawing.dll'(',',path,'sharpplot.dll')
          :Else       ⍝ use the APL workspace
              :If 0=⎕NC'#.Causeway'  ⍝ copy workspace only once into root
                  ⍝ to force update from workspace, do: ⎕EX'#.Causeway'
                  '#.Causeway'⎕NS''
                  path←LOCAL/'./'
                  #.Causeway.⎕CY path,'sharpplot'
              :EndIf
              ns.(System.Drawing←System←Causeway←#.Causeway)
          :EndIf
      :EndIf
    ∇

    WINDOWS←InitCauseway ⎕THIS   ⍝ run in this namespace too

    ∇ View sp;vw
      :If WINDOWS
          vw←⎕NEW Causeway.SharpPlotViewer sp
          vw.Show ⍬
      :Else
          3500⌶sp.RenderSvg Causeway.SvgMode.FixedAspect
      :EndIf
    ∇

    ∇ Browse filename;url
      :If ~∨/'\/'∊filename ⋄ filename←(,⎕SE.UCMD']cd'),'/',filename ⋄ :EndIf
      url←'file://',filename
      :If WINDOWS
          {}System.Diagnostics.Process.Start⊂url
      :Else
          {}⎕SH'xdg-open "',url,'"'
      :EndIf
    ∇

:EndNamespace